diff --git a/gcc/tree-ssa-loop.c b/gcc/tree-ssa-loop.c
index fef6883..0af7720 100644
--- a/gcc/tree-ssa-loop.c
+++ b/gcc/tree-ssa-loop.c
@@ -41,25 +41,35 @@ gate_tree_loop (void)
   return flag_tree_loop_optimize != 0;
 }
 
-struct gimple_opt_pass pass_tree_loop =
-{
- {
-  GIMPLE_PASS,
-  "loop",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_loop,			/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_LOOP,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+class pass_tree_loop : public gimple_opt_pass
+{
+public:
+  pass_tree_loop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "loop",
+		      OPTGROUP_LOOP,
+		      TV_TREE_LOOP,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_loop (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_tree_loop
+
+gimple_opt_pass *
+make_pass_tree_loop (context &ctxt)
+{
+  return new pass_tree_loop (ctxt);
+}
 
 /* Loop optimizer initialization.  */
 
@@ -80,25 +90,35 @@ tree_ssa_loop_init (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_tree_loop_init =
-{
- {
-  GIMPLE_PASS,
-  "loopinit",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  NULL,					/* gate */
-  tree_ssa_loop_init,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  PROP_loops,				/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+class pass_tree_loop_init : public gimple_opt_pass
+{
+public:
+  pass_tree_loop_init(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "loopinit",
+		      OPTGROUP_LOOP,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(PROP_loops),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_init (); }
+
+}; // class pass_tree_loop_init
+
+gimple_opt_pass *
+make_pass_tree_loop_init (context &ctxt)
+{
+  return new pass_tree_loop_init (ctxt);
+}
 
 /* Loop invariant motion pass.  */
 
@@ -117,25 +137,35 @@ gate_tree_ssa_loop_im (void)
   return flag_tree_loop_im != 0;
 }
 
-struct gimple_opt_pass pass_lim =
-{
- {
-  GIMPLE_PASS,
-  "lim",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_ssa_loop_im,		/* gate */
-  tree_ssa_loop_im,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_LIM,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+class pass_lim : public gimple_opt_pass
+{
+public:
+  pass_lim(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "lim",
+		      OPTGROUP_LOOP,
+		      TV_LIM,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_ssa_loop_im (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_im (); }
+
+}; // class pass_lim
+
+gimple_opt_pass *
+make_pass_lim (context &ctxt)
+{
+  return new pass_lim (ctxt);
+}
 
 /* Loop unswitching pass.  */
 
@@ -154,25 +184,35 @@ gate_tree_ssa_loop_unswitch (void)
   return flag_unswitch_loops != 0;
 }
 
-struct gimple_opt_pass pass_tree_unswitch =
-{
- {
-  GIMPLE_PASS,
-  "unswitch",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_ssa_loop_unswitch,		/* gate */
-  tree_ssa_loop_unswitch,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_LOOP_UNSWITCH,		/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_tree_unswitch : public gimple_opt_pass
+{
+public:
+  pass_tree_unswitch(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "unswitch",
+		      OPTGROUP_LOOP,
+		      TV_TREE_LOOP_UNSWITCH,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_ssa_loop_unswitch (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_unswitch (); }
+
+}; // class pass_tree_unswitch
+
+gimple_opt_pass *
+make_pass_tree_unswitch (context &ctxt)
+{
+  return new pass_tree_unswitch (ctxt);
+}
 
 /* Predictive commoning.  */
 
@@ -191,25 +231,35 @@ gate_tree_predictive_commoning (void)
   return flag_predictive_commoning != 0;
 }
 
-struct gimple_opt_pass pass_predcom =
-{
- {
-  GIMPLE_PASS,
-  "pcom",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_predictive_commoning,	/* gate */
-  run_tree_predictive_commoning,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_PREDCOM,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa_only_virtuals 	/* todo_flags_finish */
- }
-};
+class pass_predcom : public gimple_opt_pass
+{
+public:
+  pass_predcom(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "pcom",
+		      OPTGROUP_LOOP,
+		      TV_PREDCOM,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa_only_virtuals)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_predictive_commoning (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return run_tree_predictive_commoning (); }
+
+}; // class pass_predcom
+
+gimple_opt_pass *
+make_pass_predcom (context &ctxt)
+{
+  return new pass_predcom (ctxt);
+}
 
 /* Loop autovectorization.  */
 
@@ -228,26 +278,35 @@ gate_tree_vectorize (void)
   return flag_tree_vectorize;
 }
 
-struct gimple_opt_pass pass_vectorize =
-{
- {
-  GIMPLE_PASS,
-  "vect",                               /* name */
-  OPTGROUP_LOOP
-  | OPTGROUP_VEC,                       /* optinfo_flags */
-  gate_tree_vectorize,                  /* gate */
-  tree_vectorize,                       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_TREE_VECTORIZATION,                /* tv_id */
-  PROP_cfg | PROP_ssa,                  /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_vectorize : public gimple_opt_pass
+{
+public:
+  pass_vectorize(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "vect",
+		      OPTGROUP_LOOP | OPTGROUP_VEC,
+		      TV_TREE_VECTORIZATION,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_vectorize (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_vectorize (); }
+
+}; // class pass_vectorize
+
+gimple_opt_pass *
+make_pass_vectorize (context &ctxt)
+{
+  return new pass_vectorize (ctxt);
+}
 
 /* GRAPHITE optimizations.  */
 
@@ -278,45 +337,65 @@ gate_graphite_transforms (void)
   return flag_graphite != 0;
 }
 
-struct gimple_opt_pass pass_graphite =
-{
- {
-  GIMPLE_PASS,
-  "graphite0",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_graphite_transforms,		/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_GRAPHITE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
-
-struct gimple_opt_pass pass_graphite_transforms =
-{
- {
-  GIMPLE_PASS,
-  "graphite",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_graphite_transforms,		/* gate */
-  graphite_transforms,       		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_GRAPHITE_TRANSFORMS,  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+class pass_graphite : public gimple_opt_pass
+{
+public:
+  pass_graphite(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "graphite0",
+		      OPTGROUP_LOOP,
+		      TV_GRAPHITE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_graphite_transforms (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_graphite
+
+gimple_opt_pass *
+make_pass_graphite (context &ctxt)
+{
+  return new pass_graphite (ctxt);
+}
+
+class pass_graphite_transforms : public gimple_opt_pass
+{
+public:
+  pass_graphite_transforms(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "graphite",
+		      OPTGROUP_LOOP,
+		      TV_GRAPHITE_TRANSFORMS,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_graphite_transforms (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return graphite_transforms (); }
+
+}; // class pass_graphite_transforms
+
+gimple_opt_pass *
+make_pass_graphite_transforms (context &ctxt)
+{
+  return new pass_graphite_transforms (ctxt);
+}
 
 /* Check the correctness of the data dependence analyzers.  */
 
@@ -336,25 +415,35 @@ gate_check_data_deps (void)
   return flag_check_data_deps != 0;
 }
 
-struct gimple_opt_pass pass_check_data_deps =
-{
- {
-  GIMPLE_PASS,
-  "ckdd",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_check_data_deps,	        	/* gate */
-  check_data_deps,       		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_CHECK_DATA_DEPS,  	        	/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                             	/* todo_flags_finish */
- }
-};
+class pass_check_data_deps : public gimple_opt_pass
+{
+public:
+  pass_check_data_deps(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ckdd",
+		      OPTGROUP_LOOP,
+		      TV_CHECK_DATA_DEPS,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_check_data_deps (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return check_data_deps (); }
+
+}; // class pass_check_data_deps
+
+gimple_opt_pass *
+make_pass_check_data_deps (context &ctxt)
+{
+  return new pass_check_data_deps (ctxt);
+}
 
 /* Canonical induction variable creation pass.  */
 
@@ -373,25 +462,35 @@ gate_tree_ssa_loop_ivcanon (void)
   return flag_tree_loop_ivcanon != 0;
 }
 
-struct gimple_opt_pass pass_iv_canon =
-{
- {
-  GIMPLE_PASS,
-  "ivcanon",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_ssa_loop_ivcanon,		/* gate */
-  tree_ssa_loop_ivcanon,	       	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_LOOP_IVCANON,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+class pass_iv_canon : public gimple_opt_pass
+{
+public:
+  pass_iv_canon(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ivcanon",
+		      OPTGROUP_LOOP,
+		      TV_TREE_LOOP_IVCANON,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_ssa_loop_ivcanon (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_ivcanon (); }
+
+}; // class pass_iv_canon
+
+gimple_opt_pass *
+make_pass_iv_canon (context &ctxt)
+{
+  return new pass_iv_canon (ctxt);
+}
 
 /* Propagation of constants using scev.  */
 
@@ -401,27 +500,35 @@ gate_scev_const_prop (void)
   return flag_tree_scev_cprop;
 }
 
-struct gimple_opt_pass pass_scev_cprop =
-{
- {
-  GIMPLE_PASS,
-  "sccp",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_scev_const_prop,			/* gate */
-  scev_const_prop,	       		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_SCEV_CONST,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_update_ssa_only_virtuals
-					/* todo_flags_finish */
- }
-};
+class pass_scev_cprop : public gimple_opt_pass
+{
+public:
+  pass_scev_cprop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "sccp",
+		      OPTGROUP_LOOP,
+		      TV_SCEV_CONST,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_update_ssa_only_virtuals)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_scev_const_prop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return scev_const_prop (); }
+
+}; // class pass_scev_cprop
+
+gimple_opt_pass *
+make_pass_scev_cprop (context &ctxt)
+{
+  return new pass_scev_cprop (ctxt);
+}
 
 /* Record bounds on numbers of iterations of loops.  */
 
@@ -436,25 +543,35 @@ tree_ssa_loop_bounds (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_record_bounds =
-{
- {
-  GIMPLE_PASS,
-  "*record_bounds",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  tree_ssa_loop_bounds,		       	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_LOOP_BOUNDS,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0			              	/* todo_flags_finish */
- }
-};
+class pass_record_bounds : public gimple_opt_pass
+{
+public:
+  pass_record_bounds(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*record_bounds",
+		      OPTGROUP_NONE,
+		      TV_TREE_LOOP_BOUNDS,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_bounds (); }
+
+}; // class pass_record_bounds
+
+gimple_opt_pass *
+make_pass_record_bounds (context &ctxt)
+{
+  return new pass_record_bounds (ctxt);
+}
 
 /* Complete unrolling of loops.  */
 
@@ -475,25 +592,35 @@ gate_tree_complete_unroll (void)
   return true;
 }
 
-struct gimple_opt_pass pass_complete_unroll =
-{
- {
-  GIMPLE_PASS,
-  "cunroll",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_complete_unroll,		/* gate */
-  tree_complete_unroll,		       	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_COMPLETE_UNROLL,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_complete_unroll : public gimple_opt_pass
+{
+public:
+  pass_complete_unroll(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cunroll",
+		      OPTGROUP_LOOP,
+		      TV_COMPLETE_UNROLL,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_complete_unroll (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_complete_unroll (); }
+
+}; // class pass_complete_unroll
+
+gimple_opt_pass *
+make_pass_complete_unroll (context &ctxt)
+{
+  return new pass_complete_unroll (ctxt);
+}
 
 /* Complete unrolling of inner loops.  */
 
@@ -522,25 +649,35 @@ gate_tree_complete_unroll_inner (void)
   return optimize >= 2;
 }
 
-struct gimple_opt_pass pass_complete_unrolli =
-{
- {
-  GIMPLE_PASS,
-  "cunrolli",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_complete_unroll_inner,	/* gate */
-  tree_complete_unroll_inner,	       	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_COMPLETE_UNROLL,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_flow			/* todo_flags_finish */
- }
-};
+class pass_complete_unrolli : public gimple_opt_pass
+{
+public:
+  pass_complete_unrolli(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cunrolli",
+		      OPTGROUP_LOOP,
+		      TV_COMPLETE_UNROLL,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_complete_unroll_inner (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_complete_unroll_inner (); }
+
+}; // class pass_complete_unrolli
+
+gimple_opt_pass *
+make_pass_complete_unrolli (context &ctxt)
+{
+  return new pass_complete_unrolli (ctxt);
+}
 
 /* Parallelization.  */
 
@@ -561,25 +698,35 @@ tree_parallelize_loops (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_parallelize_loops =
-{
- {
-  GIMPLE_PASS,
-  "parloops",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_parallelize_loops,		/* gate */
-  tree_parallelize_loops,      		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_PARALLELIZE_LOOPS,  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+class pass_parallelize_loops : public gimple_opt_pass
+{
+public:
+  pass_parallelize_loops(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "parloops",
+		      OPTGROUP_LOOP,
+		      TV_TREE_PARALLELIZE_LOOPS,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_parallelize_loops (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_parallelize_loops (); }
+
+}; // class pass_parallelize_loops
+
+gimple_opt_pass *
+make_pass_parallelize_loops (context &ctxt)
+{
+  return new pass_parallelize_loops (ctxt);
+}
 
 /* Prefetching.  */
 
@@ -598,25 +745,35 @@ gate_tree_ssa_loop_prefetch (void)
   return flag_prefetch_loop_arrays > 0;
 }
 
-struct gimple_opt_pass pass_loop_prefetch =
-{
- {
-  GIMPLE_PASS,
-  "aprefetch",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_ssa_loop_prefetch,		/* gate */
-  tree_ssa_loop_prefetch,	       	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_PREFETCH,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+class pass_loop_prefetch : public gimple_opt_pass
+{
+public:
+  pass_loop_prefetch(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "aprefetch",
+		      OPTGROUP_LOOP,
+		      TV_TREE_PREFETCH,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_ssa_loop_prefetch (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_prefetch (); }
+
+}; // class pass_loop_prefetch
+
+gimple_opt_pass *
+make_pass_loop_prefetch (context &ctxt)
+{
+  return new pass_loop_prefetch (ctxt);
+}
 
 /* Induction variable optimizations.  */
 
@@ -636,25 +793,35 @@ gate_tree_ssa_loop_ivopts (void)
   return flag_ivopts != 0;
 }
 
-struct gimple_opt_pass pass_iv_optimize =
-{
- {
-  GIMPLE_PASS,
-  "ivopts",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_tree_ssa_loop_ivopts,		/* gate */
-  tree_ssa_loop_ivopts,		       	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_LOOP_IVOPTS,	  		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa			/* todo_flags_finish */
- }
-};
+class pass_iv_optimize : public gimple_opt_pass
+{
+public:
+  pass_iv_optimize(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ivopts",
+		      OPTGROUP_LOOP,
+		      TV_TREE_LOOP_IVOPTS,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_ssa_loop_ivopts (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_ivopts (); }
+
+}; // class pass_iv_optimize
+
+gimple_opt_pass *
+make_pass_iv_optimize (context &ctxt)
+{
+  return new pass_iv_optimize (ctxt);
+}
 
 /* Loop optimizer finalization.  */
 
@@ -667,23 +834,32 @@ tree_ssa_loop_done (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_tree_loop_done =
-{
- {
-  GIMPLE_PASS,
-  "loopdone",				/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  NULL,					/* gate */
-  tree_ssa_loop_done,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+class pass_tree_loop_done : public gimple_opt_pass
+{
+public:
+  pass_tree_loop_done(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "loopdone",
+		      OPTGROUP_LOOP,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_loop_done (); }
+
+}; // class pass_tree_loop_done
+
+gimple_opt_pass *
+make_pass_tree_loop_done (context &ctxt)
+{
+  return new pass_tree_loop_done (ctxt);
+}
